//--------------------------------------------------------------------------------------------------
// gibt Koordinaten (als int-Array) einer freie Stelle fr eine neue Zelle zurck
//--------------------------------------------------------------------------------------------------

int [] freieStelle ()
{
  int [] zufallsPos = new int [2];

  int xRandom = (int) random (width);            
  int yRandom = (int) random (height);
  boolean frei = false; 

  while (frei == false)
  {
    if ((get(xRandom, yRandom)) == Hintergrund)
    {
      frei = true;
    }
    else
    {
      xRandom = (int) random (width);
      yRandom = (int) random (height);
    }
  }
  zufallsPos [0] = xRandom;
  zufallsPos [1] = yRandom;
  return zufallsPos;
}

//--------------------------------------------------------------------------------------------------
// startet/stoppt bei Mausklick die draw-Funktion
//--------------------------------------------------------------------------------------------------

void mouseClicked()
{
  if (schlaufen == true)
  {
    noLoop ();
    schlaufen = false;
  } 
  else if (schlaufen == false)
  {
    loop ();
    schlaufen = true;
  }
}

//--------------------------------------------------------------------------------------------------
// initialisiert das Programm beim Drcken einer beliebigen Taste neu
//--------------------------------------------------------------------------------------------------

void keyPressed()                                                             // Programm neu starten
{
  background (Hintergrund);
  n = 0;                                                                      // n zurcksetzen

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [n] = new oZelle ();                                              // erste Zelle generieren
  meineZelle [n].zeichnen ();
  loop ();
  schlaufen = true;
}

//--------------------------------------------------------------------------------------------------
// zeichnet einen Kreis in einen anderen und git die Koordinaten seines Mittelpunktes als Array zurck
//--------------------------------------------------------------------------------------------------

float [] zeichne_KreisInKreis (float xUmfassung, float yUmfassung, float rUmfassung, float xKreis, float yKreis, float rKreis, color fKreis)    
{
  float xU = xUmfassung;                        // Koordinaten und Radius des umfassenden Kreises
  float yU = yUmfassung;
  float rU = rUmfassung;
  float xK = xKreis;                            // gibt Richtung des Berhrungspunktes
  float yK = yKreis;
  float rK = rKreis;
  color f = fKreis;                             // Farbe des Kreises


  float xZentrum = (rU / rK)*xK - xK;
  float yZentrum = (rU / rK)*yK - yK;
  ellipseMode (CENTER_RADIUS);
  noStroke ();
  fill (f);
  if (rK > minA)
  {
    ellipse (xU + xZentrum, yU + yZentrum, rK-minA, rK-minA);
  }
  float [] Zentrum = new float [2];
  Zentrum [0] = xU + xZentrum;
  Zentrum [1] = yU + yZentrum;
  return Zentrum;
}  

//--------------------------------------------------------------------------------------------------
// zeichnet einen Kreis mit einer bestimmten Farbe
//--------------------------------------------------------------------------------------------------

void zeichne_Kreis (float xKreis, float yKreis, float rKreis, color fKreis)           // zeichnet Kreis
{

  float xK = xKreis;
  float yK = yKreis;
  float rK = rKreis;
  color f = fKreis;                             // Farbe des Kreises

  ellipseMode (CENTER_RADIUS);
  noStroke ();
  fill (f);
  ellipse (xK, yK, rK, rK);

}  
