//--------------------------------------------------------------------------
// Klasse Tester
//--------------------------------------------------------------------------

class Tester
{

  // Variabeln

  float xTester;                                                // Koordinaten des Testers
  float yTester;
  float xZelle;                                              // Mittelpunkt und Radius der zu testenden Zelle
  float yZelle;
  float rZelle;
  int Vx;                                                    // Vx: Vorzeichen in x-Richtung (Position des Testers bezglich des Mittelpunktes der Zelle) 
  int Vy;                                                    // Vx: Vorzeichen in y-Richtung (Position des Testers bezglich des Mittelpunktes der Zelle)


  // Wertbergabe

  Tester (float xZ, float yZ, float rZ)
  {
    xZelle = xZ;
    yZelle = yZ;
    rZelle = rZ;
    xTester = xZelle;                                            // setze Startpunkt des Testers am Rand oben Mitte
    yTester = yZelle - rZelle - 1;
    Vx = (int) ((xTester-xZelle)/abs(xTester-xZelle));
    Vy = (int) ((yTester-yZelle)/abs(yTester-yZelle));
  }
  



  // ------------------------------------------------------------------------------
  // Methode: bewegen  -  In jedem Quadranten gelten andere Bewegungsvorschriften!
  // ------------------------------------------------------------------------------
  
  void Tester_bewegen ()                                              // Tester bewegen  -  In jedem Quadranten gelten andere Bewegungsvorschriften!
  {
    
    // 1. oder 3. Quadrant
    
    if (Vx*Vy<0)
    {
      if (   get( (int) xTester, (int) (yTester-Vy)) == ZelleColor    )
      {
        xTester += Vx;
      }
      else
      {
        yTester -= Vy;
      }
    }

    // 2. oder 4. Quadrant

    else if (Vx*Vy>0)
    {
      if (   get( (int) (xTester-Vx), (int) yTester) == ZelleColor     )
      {
        yTester += Vy;
      }
      else
      {
        xTester -= Vx;
      }
    }


    // auf y-Achse
    
    else if ((Vx*Vy == 0) && Vx == 0)
    {
      if (Vy <= 0)
      {
        xTester ++;
      } 
      else 
      {
        xTester --;
      }
    }

    // auf x-Achse
    
    else if ((Vx*Vy == 0) && Vy == 0)
    {
      if (Vx <= 0)
      {
        yTester --;
      } 
      else 
      {
        yTester ++;
      } 
    }
    Vx = (int) ((xTester-xZelle)/abs(xTester-xZelle));                  // Vx neu setzen
    Vy = (int) ((yTester-yZelle)/abs(yTester-yZelle));                  // Vy neu setzten
  }



  // ------------------------------------------------------------------------------
  // Methode: Zeichnen
  // ------------------------------------------------------------------------------
  
  void zeichnen ()
  {
    fill (0);
    rect(xTester, yTester, Vx*10, Vy*10);
  }
  
  
  // ------------------------------------------------------------------------------
  // Methode: testen  -  false = keine Berhrung
  // ------------------------------------------------------------------------------
  
  boolean Pixel_testen ()                                                         // testet den Pixel (Position des Testers)  -  false = keine Berhrung        
  {
    if (get((int) xTester, (int) yTester) == Hintergrund)
    {
      return false;
    }
    else 
    {
      return true;
    }
  }
 
  // ------------------------------------------------------------------------------
  
  // ------------------------------------------------------------------------------
  
  boolean finden ()                                                                 // berhrende Nachbarzellen finden gibt boolean aus (Nachbar gefunden? true oder false)
  {
    boolean fertig = false;                                                         // Suchvorgang wird abgebrochen, sobald fertig == true wird
    boolean besetzt = false;                                                        // Ergebnis des Testers
    while (fertig == false)                                                         // geschlauft, solange kein besetztes Feld gefunden wurde und der Tester nicht rundherum ist
    {
      besetzt = Pixel_testen ();
      bewegen ();
      // zeichnen ();
      if (besetzt == true)                                                           // prfen, ob etwas berhrt oder ob der Tester rundherum ist
      {
        fertig = true;
      }
      else if ((Vx == 0) && (Vy < 0))
      {
        fertig = true;  
      }
      
    }
    
    if (besetzt == true)                                                              // Ausgabe: berhrende Nachbarzelle gefunden: true - keine gefunden: false
    {
      return true;
    } 
    else
    {
      return false;
    }
  }


  // ------------------------------------------------------------------------------
  // Methode: Parameter des Testers setzten
  // ------------------------------------------------------------------------------
  
  void setter (float xZ, float yZ, float rZ)
  {
    xZelle = xZ;
    yZelle = yZ;
    rZelle = rZ;
    xTester = xZelle;                                                                         // setze Startpunkt des Testers am Rand oben Mitte
    yTester = yZelle - rZelle - 1;
    Vx = (int) ((xTester-xZelle)/abs(xTester-xZelle));                                         // Vx neu setzen
    Vy = (int) ((yTester-yZelle)/abs(yTester-yZelle));                                         // Vy neu setzten
  }
 
}





