import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class _070208_Wachstum extends PApplet {//--------------------------------------------------------------------------
// Globale Variabeln
//--------------------------------------------------------------------------

int Hintergrund = color (230);                                 // Hintergrundfarbe
int FensterColor = color (229);                                // Farbe Fenster
int c1 = color (229);                                          // Farbe Kreis innen
int c2 = color (180, 180, 120);                                // Farbe Kreis Mitte
int c3 = color (140, 140, 100);                                // Farbe Kreis Mitte

int AnzahlOeffnungen = 4;                                        // Anzahl \u00d6ffnungen
int minRandAbstand = 50;                                         // minimaler Abstand einer \u00d6ffnung zum Rand
int maxB = 180;                                                  // maximale Fensterbreite
int minB = 50;                                                   // minimale Fensterbreite

int AnzahlZellen = 500;                                          // Anzahl Zellen
float Rand = 2;                                                  // Rand der Kreise
float minR = 2;                                                  // minimaler rZelle einer Zelle
float minA = 2.5f;                                                // minimaler Abstand, darunter = ber\u00fchrt

int m = 5;                                                       // Anzal Wachstumsrunden pro Durchgang
float f = 0.05f;                                                  // Wachstum pro Durchgang
float g = 0.2f;                                                   // Verschiebung pro Durchgang

int n = 0;                                                       // Z\u00e4hler Durchg\u00e4nge
boolean schlaufen = false;                                       // draw stoppen/starten \u00fcber Mausklick (>s. Funktionen)
boolean alleGezeichnet = false;                                  // Ende ermitteln

oZelle [] meineZelle = new oZelle [AnzahlZellen];                // Zellen-Array generieren
Oeffnung [] meineOeffnung = new Oeffnung [AnzahlOeffnungen];     // Oeffnungs-Array generieren

//--------------------------------------------------------------------------
// Initialisierung
//--------------------------------------------------------------------------

//import prosvg.*;

public void setup()
{
  //size (600, 600, "prosvg.SVGOut");
  size (600, 600);
  // frameRate (5);
  background (Hintergrund);

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier \u00d6ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [0] = new oZelle ();                                              // erste Zelle generieren
  meineZelle [0].zeichnen ();
  
  // noLoop ();
}

//--------------------------------------------------------------------------
// Frame f\u00fcr Frame wiederholt
//--------------------------------------------------------------------------

public void draw ()
{

  for (int j = 1; j <= m; j++)                 // m-mal wachsen, bevor eine neue Zelle generiert wird
  {
    for (int i = 0; i <= n; i++)               // alle bestehenden Zellen "durchschlaufen"
    {
      meineZelle [i].entwickeln ();    
    }
  }
  
  if (n < AnzahlZellen-1)                      // Z\u00e4hler erh\u00f6hen und neue Zelle generieren, falls Anzahl Zellen noch nicht erreicht ist
  {
    n++;
    meineZelle [n] = new oZelle ();            // neue Zelle generieren
    meineZelle [n].zeichnen ();                // generierte Zelle zeichnen
  } else if (alleGezeichnet = false) {
    println ("alle Zellen gezeichnet");
    alleGezeichnet = true;
    // saveFrame("Ornament_Vector.svg");
  }
}


//--------------------------------------------------------------------------------------------------
// gibt Koordinaten (als int-Array) einer freie Stelle f\u00fcr eine neue Zelle zur\u00fcck
//--------------------------------------------------------------------------------------------------

public int [] freieStelle ()
{
  int [] zufallsPos = new int [2];

  int xRandom = (int) random (width);            
  int yRandom = (int) random (height);
  boolean frei = false; 

  while (frei == false)
  {
    if ((get(xRandom, yRandom)) == Hintergrund)
    {
      frei = true;
    }
    else
    {
      xRandom = (int) random (width);
      yRandom = (int) random (height);
    }
  }
  zufallsPos [0] = xRandom;
  zufallsPos [1] = yRandom;
  return zufallsPos;
}

//--------------------------------------------------------------------------------------------------
// startet/stoppt bei Mausklick die draw-Funktion
//--------------------------------------------------------------------------------------------------

public void mouseClicked()
{
  if (schlaufen == true)
  {
    noLoop ();
    schlaufen = false;
  } 
  else if (schlaufen == false)
  {
    loop ();
    schlaufen = true;
  }
}

//--------------------------------------------------------------------------------------------------
// initialisiert das Programm beim Dr\u00fccken einer beliebigen Taste neu
//--------------------------------------------------------------------------------------------------

public void keyPressed()                                                             // Programm neu starten
{
  background (Hintergrund);
  n = 0;                                                                      // n zur\u00fccksetzen

  meineOeffnung [0] = new Oeffnung (0, width/2, 0, height/2);                 // vier \u00d6ffnungen generieren
  meineOeffnung [1] = new Oeffnung (width/2, width, 0, height/2);
  meineOeffnung [2] = new Oeffnung (0, width/2, height/2, height);
  meineOeffnung [3] = new Oeffnung (width/2, width, height/2, height);

  for (int i=0; i<=3; i++) {                                                  // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [n] = new oZelle ();                                              // erste Zelle generieren
  meineZelle [n].zeichnen ();
  loop ();
  schlaufen = true;
}

//--------------------------------------------------------------------------------------------------
// zeichnet einen Kreis in einen anderen und git die Koordinaten seines Mittelpunktes als Array zur\u00fcck
//--------------------------------------------------------------------------------------------------

public float [] zeichne_KreisInKreis (float xUmfassung, float yUmfassung, float rUmfassung, float xKreis, float yKreis, float rKreis, int fKreis)    
{
  float xU = xUmfassung;                        // Koordinaten und Radius des umfassenden Kreises
  float yU = yUmfassung;
  float rU = rUmfassung;
  float xK = xKreis;                            // gibt Richtung des Ber\u00fchrungspunktes
  float yK = yKreis;
  float rK = rKreis;
  int f = fKreis;                             // Farbe des Kreises


  float xZentrum = (rU / rK)*xK - xK;
  float yZentrum = (rU / rK)*yK - yK;
  ellipseMode (CENTER_RADIUS);
  noStroke ();
  fill (f);
  if (rK > minA)
  {
    ellipse (xU + xZentrum, yU + yZentrum, rK-minA, rK-minA);
  }
  float [] Zentrum = new float [2];
  Zentrum [0] = xU + xZentrum;
  Zentrum [1] = yU + yZentrum;
  return Zentrum;
}  

//--------------------------------------------------------------------------------------------------
// zeichnet einen Kreis mit einer bestimmten Farbe
//--------------------------------------------------------------------------------------------------

public void zeichne_Kreis (float xKreis, float yKreis, float rKreis, int fKreis)           // zeichnet Kreis
{

  float xK = xKreis;
  float yK = yKreis;
  float rK = rKreis;
  int f = fKreis;                             // Farbe des Kreises

  ellipseMode (CENTER_RADIUS);
  noStroke ();
  fill (f);
  ellipse (xK, yK, rK, rK);

}  

class Oeffnung
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  float x1;                // x-Wert links
  float x2;                // x-Wert rechts
  float y1;                // y-Wert oben
  float y2;                // y-Wert unten

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Oeffnung (float l, float r, float o, float u)                    // Parameter: Parameter des Feldes der Oeffnung (links, rechts, oben, unten)
  {
    x1 = random (l + minRandAbstand, r - minRandAbstand - maxB);
    x2 = x1 + random (minB, maxB);
    y1 = random (o + minRandAbstand , u - minRandAbstand - maxB);
    y2 = y1 + random (minB, maxB);
  }

  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void zeichnen ()
  {
    fill (FensterColor);
    noStroke ();
    rectMode(CORNERS);
    rect (x1, y1, x2, y2);
  }

//--------------------------------------------------------------------------------------------------  

  public float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {x1, x2, y1, y2};
    return Geometrie;
  }  
  
//--------------------------------------------------------------------------------------------------


}

class oZelle extends Zelle
{
  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  float r1;                                // Radius bei der 1. Ber\u00fchrung
  float r2;                                // Radius bei der 2. Ber\u00fchrung
  float xB1;                               // relativer x-Wert bei der 1. Ber\u00fchrung
  float yB1;                               // relativer y-Wert bei der 1. Ber\u00fchrung  
  float xB2;                               // relativer x-Wert bei der 2. Ber\u00fchrung
  float yB2;                               // relativer y-Wert bei der 2. Ber\u00fchrung
  float [] z1 = new float [2];             // Koordinaten des Mittelpunkts des 1. Ber\u00fchrungskreises  
  float [] z2 = new float [2];             // Koordinaten des Mittelpunkts des 2. Ber\u00fchrungskreises  
  // color c1;                             // Farbe bei der 1. Ber\u00fchrung
  // color c2;                             // Farbe bei der 2. Ber\u00fchrung


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void setBeruehrungspunkt ()                          // Daten der Ber\u00fchrungen werden in Variabeln geschrieben
  {
    switch (AnzahlBeruehrungen)
    {
    case 1:
      r1 = rZelle;
      xB1 = Beruehrungspunkt [0] - xZelle;
      yB1 = Beruehrungspunkt [1] - yZelle;

    case 2:
      r2 = rZelle;
      xB2 = Beruehrungspunkt [2] - xZelle;
      yB2 = Beruehrungspunkt [3] - yZelle;
    }
  }    

  //--------------------------------------------------------------------------------------------------

  public void zeichnen ()                                      // \u00fcberdeckt die Methode in der Mutterklasse, zeichnet verschachtelte Kreise
  {
    switch (AnzahlBeruehrungen)
    {
    case 0:
      zeichne_Kreis (xZelle, yZelle, rZelle, c2);
      if (rZelle > Rand)
      {
        zeichne_Kreis (xZelle, yZelle, rZelle-Rand, c1);
      }
      break;

    case 1:
      zeichne_Kreis (xZelle, yZelle, rZelle, c2);
      z1 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB1, yB1, r1, c1);
      break;

    default:                                              // 2 oder mehr Ber\u00fchrungen
      zeichne_Kreis (xZelle, yZelle, rZelle, c3);
      z2 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB2, yB2, r2, c2);
      z1 = zeichne_KreisInKreis (z2 [0], z2 [1], r2, xB1, yB1, r1, c1);
      break;

    }
  }  

  //--------------------------------------------------------------------------------------------------

  public void setFertig (boolean f)                           // \u00fcberdecket die Methode in Mutterklasse
  {
    fertig = f;
  }    

  // --------------------------------------------------------------------------------------------------
}

class Zelle
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  boolean fertig;
  int AnzahlBeruehrungen = 0;                          // effektive Anzahl Ber\u00fchrungen
  int Beruehrungszaehler = 0;                          // wird bei jedem Durchgang auf null gesetzt und von Neuem hochgez\u00e4hlt        
  float [] Beruehrungspunkt = new float [4];           // von den max. 2 Ber\u00fchrungspunkten werden die Koordinaten gespeichert
  int col;
  float xZelle;
  float yZelle;
  float rZelle;

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Zelle ()                                              // Konstruktor ohne Parametereingabe                
  {
    fertig = false;
    col = c3;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  public void entwickeln ()                                      // l\u00e4sst die Zellen wachsen und verschiebt sie gegebenenfalls (gem. Anz Ber\u00fchrungen) 
  {
      if (getFertig () == false)                          // falls die Zelle noch nicht fertig ist
      {
        int Beruehrungen = BeruehrungenZaehlen ();        // Zelle testen
        
        switch (Beruehrungen) {
          
          case 0:                                         // keine Ber\u00fchrung -> wachsen
            wachsen();
            break;
            
          case 1:                                         // 1 Ber\u00fchrung -> bewegen, wachsen
            loeschen();
            bewegen_Ber_1();
            wachsen();
            break;
            
          case 2:                                         // 2 Ber\u00fchrung -> bewegen, wachsen
            loeschen();
            bewegen_Ber_2();
            wachsen();
            break;
            
          default:                                        // 3 oder mehr Ber\u00fchrungen
            if (getGeometrie () [2] < minR) {             // wird neu gestartet, falls sie fertig, aber zu klein ist
              reset ();          
            } else {                                      // Zelle wird als "fertig" deklariert
              setFertig (true);
            }
            break;  
        }
      }
  }

  //--------------------------------------------------------------------------------------------------
  
  public void zeichnen ()
  {
    zeichne_Kreis (xZelle, yZelle, rZelle, col);
  }

  //--------------------------------------------------------------------------------------------------

  public void loeschen ()
  {
    zeichne_Kreis (xZelle, yZelle, rZelle, Hintergrund);
  }

  //--------------------------------------------------------------------------------------------------

  public void wachsen ()
  {
    rZelle += f;
    zeichnen ();
  }

  //--------------------------------------------------------------------------------------------------

  public int BeruehrungenZaehlen ()                                                      // gibt die Anzahl Ber\u00fchrungen der Zelle zur\u00fcck
  {
    Beruehrungszaehler = 0;

  // Zellen

    for (int i=0; i<=n; i++)
    {
      float xNachbar = meineZelle [i].getGeometrie () [0];
      float yNachbar = meineZelle [i].getGeometrie () [1];
      float rNachbar = meineZelle [i].getGeometrie () [2];
      float Abstand = sqrt(sq(xNachbar - xZelle) + sq(yNachbar -yZelle));

      if (Abstand <= rZelle + minA + rNachbar && Abstand != 0)                                                          // Ber\u00fchrung
      {
        setBerKoor (xZelle + (rZelle/Abstand)*(xNachbar - xZelle), yZelle + (rZelle/Abstand)*(yNachbar - yZelle));      // Koordinaten Ber\u00fchrungspunkt setzen
      }
    }

  // \u00d6ffnungen

    for (int i=0; i < AnzahlOeffnungen; i++)
    {
      float xL = meineOeffnung [i].getGeometrie () [0];
      float xR = meineOeffnung [i].getGeometrie () [1];
      float yO = meineOeffnung [i].getGeometrie () [2];
      float yU = meineOeffnung [i].getGeometrie () [3];

      if (yZelle <= yU + rZelle + minA && yZelle >= yO - rZelle -minA && xZelle <= xR + rZelle + minA && xZelle >= xL - rZelle -minA)    // nur schlaufen, falls Ber\u00fchrung m\u00f6glich
      {
        if (yZelle <= yU && yZelle >= yO) {             // Ber\u00fchrung links oder rechts
          if (xZelle < xL) {                            // Ber\u00fchrung links
            setBerKoor (xZelle + rZelle, yZelle);
          } 
          else if (xZelle > xR) {                       // Ber\u00fchrung rechts
            setBerKoor (xZelle - rZelle, yZelle);
          }
        } 
        else if (xZelle <= xR && xZelle >= xL) {        // Ber\u00fchrung oben oder unten
          if (yZelle < yO) {                            // Ber\u00fchrung oben
            setBerKoor (xZelle, yZelle + rZelle);
          } 
          else if (yZelle > yU) {                       // Ber\u00fchrung rechts
            setBerKoor (xZelle, yZelle - rZelle);
          }
        } 
        else {                                                                     // Ber\u00fchrung an einer Ecke
          if (sqrt(sq(xL - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {           // Ber\u00fchrung unten links
            float Abstand = sqrt(sq(xL - xZelle) + sq(yU -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xL - xZelle), yZelle + (rZelle/Abstand)*(yU - yZelle));
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung unten rechts
            float Abstand = sqrt(sq(xR - xZelle) + sq(yU -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xR - xZelle), yZelle + (rZelle/Abstand)*(yU - yZelle));
          } 
          else if (sqrt(sq(xR - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung oben rechts
            float Abstand = sqrt(sq(xR - xZelle) + sq(yO -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xR - xZelle), yZelle + (rZelle/Abstand)*(yO - yZelle));
          } 
          else if (sqrt(sq(xL - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {      // Ber\u00fchrung oben links
            float Abstand = sqrt(sq(xL - xZelle) + sq(yO -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xL - xZelle), yZelle + (rZelle/Abstand)*(yO - yZelle));
          }
        }
      }

    }

  // R\u00e4nder

    if (xZelle <= rZelle + minA) {                     // Ber\u00fchrung links
      setBerKoor (xZelle - rZelle, yZelle);
    } if (xZelle >= width - rZelle - minA) {           // Ber\u00fchrung rechts
      setBerKoor (xZelle + rZelle, yZelle);
    } if (yZelle <= rZelle + minA) {                   // Ber\u00fchrung oben
      setBerKoor (xZelle, yZelle - rZelle);
    } if (yZelle >= height - rZelle - minA) {          // Ber\u00fchrung unten
      setBerKoor (xZelle, yZelle + rZelle);
    }
    
    if (Beruehrungszaehler > AnzahlBeruehrungen)       // Variable AnzahlBer\u00fchrungen macht das hoch und runter des Ber\u00fchrungsz\u00e4hlers nicht mit
    {
      AnzahlBeruehrungen = Beruehrungszaehler;
      setBeruehrungspunkt ();                          // \u00e4ndert die zeichnen-Methode (neuer Kreis im Kreis)
    }
    return (Beruehrungszaehler);
  }

  //--------------------------------------------------------------------------------------------------

  public void bewegen_Ber_1 ()                                                    // bewegen bei einer Ber\u00fchrung
  {
    xZelle += g*(xZelle - Beruehrungspunkt [0])/rZelle;                    // Mittelpunkt verschieben
    yZelle += g*(yZelle - Beruehrungspunkt [1])/rZelle;
  }

  //--------------------------------------------------------------------------------------------------

  public void bewegen_Ber_2 ()                                                    // bewegen bei zwei Ber\u00fchrungen
  {
    float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
    float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
    float AbstandMitte = sqrt(sq(xMitte - xZelle) + sq(yMitte - yZelle));
    // float CosinusWinkel = AbstandMitte / rZelle;
    if (AbstandMitte > 0.1f) {                                               // Rundungsungenauigkeiten vermeiden
      xZelle += g*((xZelle - xMitte)/AbstandMitte);                         // Mittelpunkt verschieben
      yZelle += g*((yZelle - yMitte)/AbstandMitte);
    } else {
      setFertig (true);
    }
  }

  //--------------------------------------------------------------------------------------------------

  public void setBerKoor (float x, float y)                    // erh\u00f6ht den Ber\u00fchrungsz\u00e4hler und schreibt die Koordinaten des Ber\u00fchrungspunktes ins Array
  {
    Beruehrungszaehler++;
    if (Beruehrungszaehler<=2)
    {
      Beruehrungspunkt [Beruehrungszaehler*2-2] = x;    // x-Wert Ber\u00fchrunspunkt
      Beruehrungspunkt [Beruehrungszaehler*2-1] = y;    // y-Wert Ber\u00fchrunspunkt
    }
  }

  //--------------------------------------------------------------------------------------------------

  public void reset ()                                    // setzt die Zelle zur\u00fcck (Zelle wird "neu genereiert")
  {
    loeschen ();                                   // Zelle l\u00f6schen

    fertig = false;                                // Variabeln zur\u00fccksetzen
    col = c3;
    int [] Position = freieStelle ();
    xZelle = Position [0];
    yZelle = Position [1];
    rZelle = 0;
  }

  //--------------------------------------------------------------------------------------------------

  public boolean getFertig ()                                // Variable "fertig" auslesen     
  {
    return fertig;
  }  

  //--------------------------------------------------------------------------------------------------  

  public float [] getGeometrie ()                            // Geometrie auslesen
  {
    float [] Geometrie = {
      xZelle, yZelle, rZelle    };
    return Geometrie;
  }  

  //--------------------------------------------------------------------------------------------------

  public void setFertig (boolean f)                           // Variable "fertig" setzen und Zelle neu zeichnen
  {
    fertig = f;
    zeichnen ();
  }    

  // --------------------------------------------------------------------------------------------------

  public void setFarbe (int c)                              // Methode: Farbe setzen
  {
    col = c;
  }    

  //--------------------------------------------------------------------------------------------------

  public void setBeruehrungspunkt ()                          // wird in Unterklasse \u00fcberdeckt
  {
    
  }    

  //--------------------------------------------------------------------------------------------------

}
static public void main(String args[]) {   PApplet.main(new String[] { "_070208_Wachstum" });}}